// 001 u_server_socket
// 09 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_server_socket;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
        StdCtrls
      , ExtCtrls, ComCtrls
      ;

    const wm_asynch_select= wm_User;

    type TForm1= class(TForm)
                   Panel1: TPanel;
                   port_edit_: TEdit;
                   go: TButton;
                   clear_: TButton;
                   wsa_startup_: TPanel;
                   Socket_: TPanel;
                   wsa_async_select_: TPanel;
                   bind_: TPanel;
                   listen_: TPanel;
                   close_socket_: TPanel;
                   exit_: TButton;
                   Memo1: TMemo;
    close_clients_: TPanel;
                   procedure wsaStartup_Click(Sender: TObject);
                   procedure Socket_Click(Sender: TObject);
                   procedure wsaAsyncSelect_Click(Sender: TObject);
                   procedure CloseSocket_Click(Sender: TObject);
                   procedure Bind_Click(Sender: TObject);
                   procedure Listen_Click(Sender: TObject);
                   procedure goClick(Sender: TObject);
                   procedure FormCreate(Sender: TObject);
                   procedure clear_Click(Sender: TObject);
                   procedure exit_Click(Sender: TObject);
    procedure close_clients_Click(Sender: TObject);
                 private
                   procedure handle_wm_async_select(var Msg: TMessage);
                                message wm_asynch_select;
                   public
                 end;

    var Form1: TForm1;

  implementation
    uses WinSock
        , u_types_constants, u_characters
        , u_c_log, u_c_display
        , u_winsock
        , u_c_server_client_socket_list
      ;

    {$R *.DFM}

 
    const k_listen_queue_size= 5;
    var g_wsa_data: twsaData;
        g_server_socket_handle: tSocket= Invalid_socket;
        g_c_server_client_socket_list: c_server_client_socket_list= Nil;

    procedure set_panel_color(p_c_panel: tPanel; p_color: Integer);
      begin
        p_c_panel.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    function f_name_and_handle(p_socket_handle: tSocket): String;
      begin
        if p_socket_handle= g_server_socket_handle
          then result:= 'server '+ f_socket_name(p_socket_handle)
          else result:= 'a_client '+ f_socket_name(p_socket_handle);
      end; // f_name_and_handle

    // -- user actions

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_panel_color(wsa_startup_, clLime);
        set_panel_color(socket_, clRed);
        set_panel_color(bind_, clRed);
        set_panel_color(wsa_async_select_, clRed);
        set_panel_color(listen_, clRed);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.wsaStartup_Click(Sender: TObject);

      procedure display_wsa_data;
        begin
          with g_wsa_data do
          begin
            display('wVersion '+ IntToHex(wVersion, 4));
            display('wHighVersion '+ IntToHex(wHighVersion, 4));
            display('szDescription '+ string(szDescription));
            display('szSystemStatus '+ string(szSystemStatus));
            display('iMaxSockets '+ IntToStr(iMaxSockets));
            display('iMaxUdpDg '+ IntToStr(iMaxUdpDg));
            if lpVendorInfo= nil
              then display('lpVendorInfo NIL');
          end;
        end; // display_wsa_data

      var l_version: Word;
          l_result: Integer;

      begin // display_wsa_data
        display_line;
        display('> wsaStartup_Click');
        // -- l_version:= $0202;
        l_version:= $0101;
        display(':wsaStartup()');
        l_result:= wsaStartup(l_version, g_wsa_data);
        if l_result<> 0
          then display_socket_error_halt(Invalid_socket, 's.wsaStartup '+ IntToStr(l_result),
              WSAGetLastError);
        display('< wsaStartup_Click');

        display_wsa_data;

        set_panel_color(wsa_startup_, clRed);
        set_panel_color(socket_, clLime);
      end; // wsaStartup

    procedure TForm1.Socket_Click(Sender: TObject);
      begin
        display('');
        display('> Socket_Click');

        // -- allocate the Socket record, and get back its handle
        display(':Socket(pf_Inet, Sock_Stream, IpProto_IP)');
        g_server_socket_handle:= Socket(PF_INET, SOCK_STREAM, IPPROTO_IP);

        if g_server_socket_handle= INVALID_SOCKET
          then display_socket_error_halt(INVALID_SOCKET, 's.Socket',
                WSAGetLastError);

        display('< Socket_Click '+ f_socket_handle_string(g_server_socket_handle));

        // -- also create the client socket list
        display('create_server_client_socket_list');
        g_c_server_client_socket_list:= c_server_client_socket_list.create_server_client_socket_list('server_client_list');

        set_panel_color(socket_, clRed);
        set_panel_color(wsa_async_select_, clLime);
      end; // Socket_clic

    procedure TForm1.wsaAsyncSelect_Click(Sender: TObject);
      var l_result: Integer;
      begin
        display_line;
        display('> wsaAsyncSelect_Clic');

        // -- specifies which WinSocket events should be monitored
        display(':wsaAsyncSelect('+ IntToStr(g_server_socket_handle)+
            ', ACCEPT+ READ+ WRITE +CLOSE)');
        l_result:= wsaAsyncSelect(g_server_socket_handle, Handle,
            wm_asynch_select,
            FD_ACCEPT+ FD_READ+ FD_WRITE+ FD_CLOSE);
        if l_result<> 0
          then display_socket_error_halt(g_server_socket_handle, 's.wsaAsyncSelect',
              WSAGetLastError);

        display('< wsaAsyncSelect_Clic');
        set_panel_color(wsa_async_select_, clRed);
        set_panel_color(bind_, clLime);
      end; // wsaAsyncSelect

    procedure TForm1.Bind_Click(Sender: TObject);
        // -- assigns an address to the socket
      var l_result: Integer;
          l_address_socket_in: tSockAddrIn;
          l_port: Integer;
      begin
        display_line;
        display('> Bind_Click');

        l_port:= StrToInt(port_edit_.Text);

        FillChar(l_address_socket_in, sizeof(l_address_socket_in), 0);
        with l_address_socket_in do
        begin
          sin_family:= af_Inet;
          sin_port:= hToNs(l_port);
          sin_addr.s_addr:= InAddr_Any; // $00000000
        end;

        display(':Bind('+ IntToStr(g_server_socket_handle)+ ', '+ IntToStr(l_port)+ ', )');
        l_result:= Bind(g_server_socket_handle, l_address_socket_in,
            sizeof(l_address_socket_in));
        if l_result<> 0
          then display_socket_error_halt(g_server_socket_handle, 's.Bind',
              WSAGetLastError);

        display('< Bind_Click '+ f_socket_name(g_server_socket_handle));
        set_panel_color(bind_, clRed);
        set_panel_color(listen_, clLime);
      end; // bind_Click

    procedure TForm1.Listen_Click(Sender: TObject);
      var l_result: Integer;
      begin
        display_line;
        display('> Listen_Click');

        display(':Listen('+ IntToStr(g_server_socket_handle)+ ', )');
        l_result:= Listen(g_server_socket_handle, k_listen_queue_size);
        if l_result<> 0
          then display_socket_error_halt(g_server_socket_handle, 's.Listen',
              WSAGetLastError);

        display('< Listen_Click '+ f_socket_name(g_server_socket_handle));

        set_panel_color(listen_, clRed);
        set_panel_color(close_clients_, clLime);
        set_panel_color(close_socket_, clLime);
      end; // Listen_Click

    procedure TForm1.close_clients_Click(Sender: TObject);
      begin
        display('');
        display('> close_clients_Click');
        g_c_server_client_socket_list.close_server_client_socket_list;
        display('< close_clients_Click');
      end; // close_clients_Click

    procedure TForm1.CloseSocket_Click(Sender: TObject);
      var l_result: Integer;
      begin
        display('');
        display('> CloseSocket_Clic '+ f_name_and_handle(g_server_socket_handle));

        if g_server_socket_handle= INVALID_SOCKET
          then display('INVALID_SOCKET (already_closed ?)')
          else begin
              display(':CloseSocket('+ IntToStr(g_server_socket_handle)+ ')');
              l_result:= CloseSocket(g_server_socket_handle);
              if l_result<> 0
                then display_socket_error_halt(g_server_socket_handle, 'c.CloseSocket',
                      WSAGetLastError)
                else begin
                    g_server_socket_handle:= INVALID_SOCKET;
                  end;
            end;

        display('< CloseSocket_Clic');
        set_panel_color(wsa_startup_, clLime);
        set_panel_color(close_socket_, clRed);
      end; // CloseSocket_Click

    procedure TForm1.goClick(Sender: TObject);
      begin
        wsaStartup_Click(self);
        Socket_Click(self);
        wsaAsyncSelect_Click(self);
        Bind_Click(self);
        Listen_Click(self);
      end; // goClick

    procedure tForm1.handle_wm_async_select(var Msg: TMessage);
      // -- wParam: hSocket, lo(lParam): notification, hi(lParam): error

      procedure handle_fd_accept_notification(p_socket: tSocket);
          // -- A Client was connected.
          // -- the Server spans a socket by calling Accept
        var l_address_socket_in: tSockAddrIn;
            l_address_size: Integer;
            l_server_client_socket: tSocket;
        begin
          display('> fd_accept('+ IntToStr(p_socket)+ ')');

          // -- the socket handle received by fd_accept
          display(':Accept('+ IntToStr(p_socket)+ ',...)');

          // -- must use a variable
          l_address_size:= sizeof(l_address_socket_in);
          l_server_client_socket:= Accept(p_socket, @l_address_socket_in, @l_address_size);
          display('=> client= '+ f_socket_name(l_server_client_socket));

          // -- add to the list to be able to close them
          g_c_server_client_socket_list.f_c_add_unique_server_client_socket(l_server_client_socket);

          display('< fd_Accept');
        end; // handle_fd_accept_notification

      procedure handle_fd_write_notification(p_socket: Integer);
        var l_c_server_client_socket: c_server_client_socket;
        begin
          display('> fd_write('+ f_name_and_handle(p_socket)+ ')');

          if p_socket= g_server_socket_handle
            then display('fd_write: not_server_socket_handle (ok)'
                    + ' p_sock ='+ IntToStr(p_socket)+ ' cli= '+ IntToStr(g_server_socket_handle))
            else begin
                l_c_server_client_socket:= g_c_server_client_socket_list.f_c_find_server_client_socket_by_handle(p_socket);
                if l_c_server_client_socket<> Nil
                  then begin
                      with l_c_server_client_socket do
                        // -- could call a sending method
                    end
              end;

          display('< fd_write');
        end; // handle_fd_write_notification

      procedure handle_fd_read_notification(p_socket: tSocket);
          // -- a server_client_socket received some data
        var l_c_server_client_socket: c_server_client_socket;
        begin
          display('> fd_read('+ f_name_and_handle(p_socket)+ ')');

          // -- locate the server_client_socket
          if p_socket= g_server_socket_handle
            then begin
                display('server_handle_read');
                // -- server should not receive much
              end
            else begin
                display('server_client_handle_read');
                // -- one of the c_server_client_sockets
                // -- find this socket
                l_c_server_client_socket:= g_c_server_client_socket_list.f_c_find_server_client_socket_by_handle(p_socket);

                if l_c_server_client_socket<> Nil
                  then begin
                      // -- let the user of the c_server_socket handle the reception and analysis
                      l_c_server_client_socket.handle_fd_read_notification;
                    end
                  else display('*** fd_write: no_client_server_socket_handle'
                    + ' p_sock ='+ IntToStr(p_socket));
              end;

          display('< fd_read');
        end; // handle_fd_read_notification

      procedure handle_fd_close_notification(p_socket: Integer);
        var l_status: Integer;
            l_linger: TLinger;
            l_absolute_linger: array[0..3] of char absolute l_linger;

            l_index_of_server_client_socket: Integer;
        begin
          display('> fd_close('+ f_name_and_handle(p_socket)+ ')');
          display('the remote client closed');

          // -- locate the server_client_socket
          if p_socket= g_server_socket_handle
            then begin
                display('close_server_handle');
              end
            else begin
                display('a_remote_client_closed');
                // -- find this socket
                l_index_of_server_client_socket:= g_c_server_client_socket_list.f_index_of(p_socket);
              end;

          // -- close our client socket
          display(':wsaIsBlocking');
          if WSAIsBlocking
            then
              begin
                display(':wsaCancelBlockingCall');
                WSACancelBlockingCall;
              end;

          display(':ShutDown('+ IntToStr(p_socket)+ ', )');
          ShutDown(p_socket, 2);
          l_linger.l_onoff:= 1;
          l_linger.l_linger:= 0;

          display(':SetSockOpt('+ IntToStr(p_socket)+ ', )');
          SetSockOpt(p_socket, Sol_Socket, So_Linger,
              l_absolute_linger, sizeof(l_linger));

          display(':CloseSocket('+ IntToStr(p_socket)+ ')');
          l_status:= CloseSocket(p_socket);
          if l_status<> 0
            then display_socket_error_halt(p_socket, 's.Disconnect (closesocket)',
                WSAGetLastError);

          // -- Free and delte the server_client socket
          if l_index_of_server_client_socket< 0
            then display('*** fd_close: no_c_server_client_socket')
            else begin
                g_c_server_client_socket_list.f_c_server_client_socket(l_index_of_server_client_socket).Free;
                g_c_server_client_socket_list.delete_server_client_socket(l_index_of_server_client_socket);
              end;

          display('< fd_close');
        end; // handle_fd_close_notification

      var l_param: Integer;
          l_error, l_notification: Integer;
          l_socket_handle: Integer;

      begin // handle_wm_async_select
        l_param:= Msg.lParam;
        l_socket_handle:= Msg.wParam;

        display_line;
        display('> handle_wm_async_select L=$'+ IntToHex(l_param, 4)
            + ' W='+ IntToStr(l_socket_handle));

        // -- extract the error and the notification code from l_param
        l_error:= wsaGetSelectError(l_param);
        l_notification:= wsaGetSelectEvent(l_param);

        if l_error= 0
          then display('notif= '+ f_socket_notification_name(l_notification))
          else display('notif= '+ f_socket_notification_name(l_notification)
              + ' err= '+ IntToStr(l_error));

        if l_error<= wsaBaseErr
          then
            case l_notification of
              FD_ACCEPT: handle_fd_accept_notification(l_socket_handle);
              FD_CONNECT: display('no server fd_connect');
              FD_WRITE: handle_fd_write_notification(l_socket_handle);
              FD_READ: handle_fd_read_notification(l_socket_handle);
              FD_CLOSE: handle_fd_close_notification(l_socket_handle);
            end // case
          else begin
              if l_notification= FD_CLOSE
                then handle_fd_close_notification(l_socket_handle)
                else display_socket_error_halt(l_socket_handle,
                  's.handle_wm_async_select '+ f_socket_notification_name(l_notification),
                  l_error);
            end;

        display('< handle_wm_async_select');
      end; // handle_wm_async_select

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click


end.
